local QW_MOVEWINDOW = "NONE"
local watch = {}
QuickWarnings_CheckingBuffs = { }
QuickWarnings_CheckingBuffs_Ignore = {	"Bear Form", "Dire Bear Form", "Aquatic Form", "Cat Form", "Travel Form",
										"Moonkin Form", "Tree of Life Form", "Flight Form", "Swift Flight Form",
										"Battle Stance", "Defensive Stance", "Berserker Stance",
										"Blood Presence", "Frost Presence", "Unholy Presence",
										"Find Minerals", "Find Herbs", "Find Fish", "Find Treasure",}
QuickWarnings_CheckingBuffs_Researching = {}

local timer
local tcount
local ttcount

function QuickWarnings_SlashCommand(cmd)
	if (cmd == "mv") then
		if (#watch > 19) then
			ChatFrame1:AddMessage("Quick Warnings: You can't get enough, can you? :D", 0, 1, 0);
		elseif (#watch > 10) then
			ChatFrame1:AddMessage("Quick Warnings: Are you having fun? :)", 0, 1, 0);
		end
	
		tcount = 4
		ttcount = GetTime()
		timer = ttcount + 7
		QuickWarningsFrame:SetWidth(64)
		QuickWarningsFrame:SetHeight(64)
		
		--AddSpellToWatch(QW_MOVEWINDOW, "Interface\\Icons\\INV_Misc_QuestionMark")
	elseif (cmd == "list") then
		for i = 1, #QuickWarnings_CheckingBuffs do
			ChatFrame1:AddMessage("["..i.."] "..QuickWarnings_CheckingBuffs[i], 0, 1, 0);
		end
	elseif (cmd == "il") then
		for i = 1, #QuickWarnings_CheckingBuffs_Ignore do
			ChatFrame1:AddMessage("["..i.."] "..QuickWarnings_CheckingBuffs_Ignore[i], 1, 0, 0);
		end
	elseif (cmd == "rl") then
		for i = 1, #QuickWarnings_CheckingBuffs_Researching do
			ChatFrame1:AddMessage("["..i.."] "..QuickWarnings_CheckingBuffs_Researching[i][1], 1, 1, 0);
		end
	elseif (string.sub(cmd, 1, 2) == "c ") then
		local name = string.sub(cmd, 2 - string.len(cmd))
		QuickWarnings_CheckingBuffs[#QuickWarnings_CheckingBuffs + 1] = name
		for i = 1, #QuickWarnings_CheckingBuffs_Ignore do
			if (QuickWarnings_CheckingBuffs_Ignore[i] == name) then
				QuickWarnings_CheckingBuffs_Ignore[i] = QuickWarnings_CheckingBuffs_Ignore[#QuickWarnings_CheckingBuffs_Ignore]
				QuickWarnings_CheckingBuffs_Ignore[#QuickWarnings_CheckingBuffs_Ignore] = nil
			end
		end
		ChatFrame1:AddMessage(name.." is now always considered by Quick Warnings.", 0, 1, 0);
	elseif (string.sub(cmd, 1, 2) == "i ") then
		local name = string.sub(cmd, 2 - string.len(cmd))
		if (name == QW_MOVEWINDOW) then
			ChatFrame1:AddMessage("You can't ignore "..QW_MOVEWINDOW, 1, 0.8, 0.7);
		else
			QuickWarnings_CheckingBuffs_Ignore[#QuickWarnings_CheckingBuffs_Ignore + 1] = name
			for i = 1, #QuickWarnings_CheckingBuffs do
				if (QuickWarnings_CheckingBuffs[i] == name) then
					QuickWarnings_CheckingBuffs[i] = QuickWarnings_CheckingBuffs[#QuickWarnings_CheckingBuffs]
					QuickWarnings_CheckingBuffs[#QuickWarnings_CheckingBuffs] = nil
				end
			end
			ChatFrame1:AddMessage(name.." is now being ignored by Quick Warnings.", 1, 0, 0);
		end
	else
		ChatFrame1:AddMessage("/qw: this help", 1, 0.8, 0.7);
		ChatFrame1:AddMessage("/qw list: list all checked buffs (there might be a lot!)", 1, 0.8, 0.7);
		ChatFrame1:AddMessage("/qw il: list all ignored buffs (there are be a lot!)", 1, 0.8, 0.7);
		ChatFrame1:AddMessage("/qw rl: list all buffs still in research (there might be a lot!)", 1, 0.8, 0.7);
		ChatFrame1:AddMessage("/qw i Xxx: start ignoring buff with name Xxx", 1, 0.8, 0.7);
		ChatFrame1:AddMessage("/qw c Xxx: include buff with name Xxx to the list", 1, 0.8, 0.7);
		ChatFrame1:AddMessage("/qw mv: Drag the box to move Quick Warnings position", 1, 0.8, 0.7);
	end
end

function QuickWarnings_OnMouseDown(self)
		--ChatFrame1:AddMessage("/qw down", 1, 0.8, 0.7);
	self:StartMoving()
	timer = GetTime() + 60 * 60 * 24
end

function QuickWarnings_OnMouseUp(self)
		--ChatFrame1:AddMessage("/qw up", 1, 0.8, 0.7);
	self:StopMovingOrSizing()
	timer = GetTime() + 4
end

function QuickWarnings_OnLoad(self)
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
	
	SlashCmdList["QuickWarnings"] = QuickWarnings_SlashCommand;
	SLASH_QuickWarnings1 = "/qw"
	
	self:SetBackdropColor(0.3, 0.2, 0.6)
end 

local time = 0
function QuickWarnings_OnUpdate(self)
	if (timer) then
		--local barBG = getglobal(self:GetName().."Border")
		if (timer < GetTime()) then
			timer = nil
			tcount = nil
			ttcount = nil
			QuickWarningsFrame:SetWidth(0.01)
			QuickWarningsFrame:SetHeight(0.01)
			RemoveSpellFromWatch(QW_MOVEWINDOW)
		elseif (tcount > 0) then
			if (ttcount + 1 < GetTime()) then
				ttcount = GetTime() - 0.8
				tcount = tcount - 1
				AddSpellToWatch(QW_MOVEWINDOW, "Interface\\Icons\\INV_Misc_QuestionMark")
				watch[#watch][4] = GetTime() + 60 * 60
			end
		end
	end

	if (time < GetTime()) then
		time = GetTime() + 1
		
		local i = 1
		local duration = 0
		while true do
			local buffName, _, _, _, _, _, buffFinishTime, isMine = UnitBuff("player", i);
			if (buffName == nil) then
				break
			end
			if (isMine) then
				for i = 1, #watch do
					if (buffName == watch[i][2]) then
						if (buffFinishTime - GetTime() > 5000) then
							watch[i][4] = 0
							RemoveSpellFromWatch(watch[i][2])
						else
							watch[i][4] = buffFinishTime
						end
					end
				end
			end
			i = i + 1
		end

		ReOrder()
	end
	
	for i = 1, #watch do
		if (watch[i][1]:GetAlpha() == 1) then
			watch[i][1]:SetWidth(56 + 8 * math.sin(4 * (watch[i][3] + GetTime())))
			watch[i][1]:SetHeight(56 + 8 * math.sin(4 * (watch[i][3] + GetTime())))
			
			watch[i][6]:SetWidth(56 + 8 * math.sin(4 * (watch[i][3] + GetTime() - 0.3)))
			watch[i][6]:SetHeight(56 + 8 * math.sin(4 * (watch[i][3] + GetTime() - 0.3)))
			watch[i][7]:SetWidth(56 + 8 * math.sin(4 * (watch[i][3] + GetTime() - 0.7)))
			watch[i][7]:SetHeight(56 + 8 * math.sin(4 * (watch[i][3] + GetTime() - 0.7)))
		end
	end

	ReorganizeWatchingBuffs()
end

function RemoveSpellFromWatch(name)
	local still = true
	
	while (still) do
		still = false
		for i = 1, #watch do
			if (watch[i][2] == name) then
				watch[i][1]:ClearAllPoints()
				watch[i][1]:Hide()
				if (watch[i][6]) then
					watch[i][6]:ClearAllPoints()
					watch[i][6]:Hide()
					watch[i][7]:ClearAllPoints()
					watch[i][7]:Hide()
				end
				if (watch[i][4] - 0.4 < GetTime()) then
					PointDown(name)
				else
					PointUp(name)
				end
				watch[i] = watch[#watch]
				watch[#watch] = nil
				--for j = i, #watch do
				--	watch[j] = watch[j + 1]
				--end
				still = true
				break
			end
		end
	end

--	ReorganizeWatchingBuffs()
end

function ReOrder ()
	for i = 1, #watch - 1 do
		for j = i + 1, #watch do
			if (watch[i][4] > watch[j][4]) then
				watch[i], watch[j] = watch[j], watch[i]

				local _, _, _, x, y = watch[i][1]:GetPoint()
				watch[i][1]:ClearAllPoints()
				watch[i][1]:SetPoint("CENTER", "QuickWarningsFrame", "CENTER", x, math.min(y, -12))
				watch[i][9] = math.min(y, -8)

				_, _, _, x, y = watch[j][1]:GetPoint()
				watch[j][1]:ClearAllPoints()
				watch[j][1]:SetPoint("CENTER", "QuickWarningsFrame", "CENTER", x, math.max(12, y))
				watch[j][9] = math.max(8, y)

			end
		end
	end
end

function ReorganizeWatchingBuffs()

	for i = 1, #watch do
		local _, _, _, x, y = watch[i][1]:GetPoint()
		local xx, yy = 66 * (i - 1), 24

		watch[i][8] = watch[i][8] + (xx - x) * 0.04
		watch[i][9] = watch[i][9] + (yy - y) * 0.04
		
		watch[i][8] = watch[i][8] * 0.97
		watch[i][9] = watch[i][9] * 0.97
		
		local dx = math.abs(xx - x)
		local dy = math.abs(yy - y)
		if (dx < 3 or dx > 60) then
			watch[i][8] = watch[i][8] * 0.9
			--	watch[i][8] = 0
			--	x = xx
		end
		if (dy < 3 or dy > 60) then
			watch[i][9] = watch[i][9] * 0.9
			--	watch[i][9] = 0
			--	y = yy
		end

		x = x + watch[i][8] * 0.1
		y = y + watch[i][9] * 0.1
		watch[i][1]:ClearAllPoints()
		watch[i][1]:SetPoint("CENTER", "QuickWarningsFrame", "BOTTOMLEFT", x, y)
		if (watch[i][6]) then
			watch[i][6]:ClearAllPoints()
			watch[i][6]:SetPoint("CENTER", "QuickWarningsFrame", "BOTTOMLEFT", x - watch[i][8], y - watch[i][9])
			watch[i][7]:ClearAllPoints()
			watch[i][7]:SetPoint("CENTER", "QuickWarningsFrame", "BOTTOMLEFT", x - 2 * watch[i][8], y - 2 * watch[i][9])
		end
	end
end

function CreateWarningBuffFrame(name, icon, i)
	local f = CreateFrame("Frame", name, UIParent)
	f:SetFrameStrata("BACKGROUND")
	f:SetWidth(64) 
	f:SetHeight(64)

	local t = f:CreateTexture(nil,"BACKGROUND")
	t:SetTexture(icon)
	t:SetAllPoints(f)
	f.texture = t

	f:SetPoint("CENTER", "QuickWarningsFrame", "CENTER", 66 * i, 31)
	
	return f, t
end

function AddSpellToWatch(name, icon)
	if (name == QW_MOVEWINDOW) then
		if (#watch > 20) then
			return
		end
	end

	if (isInIgnore(name)) then
		return
	end
	
	
--======================================================================--
-- Tweak to make fire mage's "Heating Up" look like a "Inferno Blast"	--
--	Compare name as they are in the Quick Warnings list					--
--	Must icon from spell ID. Look for it in www.thottbot.com			--
--======================================================================--
	if (name == "Heating Up") then
		local _
		_,_, icon = GetSpellInfo(108853)	-- Inferno Blast spell ID
	end
--=================================================================--

	local f = CreateWarningBuffFrame(name, icon, #watch)
	f:Show()
	
	local ff, fff = nil, nil
	if (not CheckIfSo(name)) then
		f:SetAlpha(0.5)
		f:SetWidth(56) 
		f:SetHeight(56)
	else
		local tt
		ff, tt = CreateWarningBuffFrame(name, icon, #watch)
		tt:SetBlendMode("ADD")
		ff:SetAlpha(0.5)
		ff:Show()
		fff, tt = CreateWarningBuffFrame(name, icon, #watch)
		tt:SetBlendMode("ADD")
		fff:SetAlpha(0.25)
		fff:Show()

		--f:ClearAllPoints()
		--f:SetPoint("CENTER", "QuickWarningsFrame", "CENTER", 66 * i, 24)
		--ff:ClearAllPoints()
		--ff:SetPoint("CENTER", "QuickWarningsFrame", "CENTER", 66 * i, 24)
		--fff:ClearAllPoints()
		--fff:SetPoint("CENTER", "QuickWarningsFrame", "CENTER", 66 * i, 24)
	end

	watch[#watch + 1] = {f, name, GetTime(), GetTime(), icon, ff, fff, 0, 48}
	
	time = GetTime() + 0.1
end

function isInIgnore(name)
	if (name == QW_MOVEWINDOW) then
		return false
	end

	for i = 1, #QuickWarnings_CheckingBuffs_Ignore do
		if (QuickWarnings_CheckingBuffs_Ignore[i] == name) then
			return true
		end
	end
	return false
end

function CheckIfSo(name)
	if (name == QW_MOVEWINDOW) then
		return true
	end

	for i = 1, #QuickWarnings_CheckingBuffs do
		if (QuickWarnings_CheckingBuffs[i] == name) then
			return true
		end
	end
	local found = false
	for i = 1, #QuickWarnings_CheckingBuffs_Researching do
		if (QuickWarnings_CheckingBuffs_Researching[i][1] == name) then
			found = true
		end
	end
	if (not found) then
		QuickWarnings_CheckingBuffs_Researching[#QuickWarnings_CheckingBuffs_Researching + 1] = {name, 0}
	end
	return false
end

function PointDown(name)
	for i = 1, #QuickWarnings_CheckingBuffs_Researching do
		if (QuickWarnings_CheckingBuffs_Researching[i][1] == name) then
			QuickWarnings_CheckingBuffs_Researching[i][2] = QuickWarnings_CheckingBuffs_Researching[i][2] - 2
--DEFAULT_CHAT_FRAME:AddMessage(QuickWarnings_CheckingBuffs_Researching[i][1]..":"..QuickWarnings_CheckingBuffs_Researching[i][2]);
			break
		end
	end
	CheckLists()
end

function PointUp(name)
	for i = 1, #QuickWarnings_CheckingBuffs_Researching do
		if (QuickWarnings_CheckingBuffs_Researching[i][1] == name) then
			QuickWarnings_CheckingBuffs_Researching[i][2] = QuickWarnings_CheckingBuffs_Researching[i][2] + 1
--DEFAULT_CHAT_FRAME:AddMessage(QuickWarnings_CheckingBuffs_Researching[i][1]..":"..QuickWarnings_CheckingBuffs_Researching[i][2]);
			break
		end
	end
	CheckLists()
end

function CheckLists()
	for i = 1, #QuickWarnings_CheckingBuffs_Researching do
		local v = QuickWarnings_CheckingBuffs_Researching[i][2]
		if (v == 3) then
			QuickWarnings_CheckingBuffs_Researching[i][2] = 50
			QuickWarnings_CheckingBuffs[#QuickWarnings_CheckingBuffs + 1] = QuickWarnings_CheckingBuffs_Researching[i][1]
			ChatFrame1:AddMessage(QuickWarnings_CheckingBuffs_Researching[i][1].." is now always considered by Quick Warnings.", 0, 1, 0);
			QuickWarnings_CheckingBuffs_Researching[i] = QuickWarnings_CheckingBuffs_Researching[#QuickWarnings_CheckingBuffs_Researching]
			QuickWarnings_CheckingBuffs_Researching[#QuickWarnings_CheckingBuffs_Researching] = nil
			break;
		elseif (v == -6 or v == -7) then
			QuickWarnings_CheckingBuffs_Researching[i][2] = -100
			QuickWarnings_CheckingBuffs_Ignore[#QuickWarnings_CheckingBuffs_Ignore + 1] = QuickWarnings_CheckingBuffs_Researching[i][1]
			ChatFrame1:AddMessage(QuickWarnings_CheckingBuffs_Researching[i][1].." is now being ignored by Quick Warnings.", 1, 0, 0);
			QuickWarnings_CheckingBuffs_Researching[i] = QuickWarnings_CheckingBuffs_Researching[#QuickWarnings_CheckingBuffs_Researching]
			QuickWarnings_CheckingBuffs_Researching[#QuickWarnings_CheckingBuffs_Researching] = nil
			break;
		end
	end
	
--	for i = 1, #QuickWarnings_CheckingBuffs_Researching do
--		for j = 1, #QuickWarnings_CheckingBuffs do
--			if (QuickWarnings_CheckingBuffs_Researching[i][1] == QuickWarnings_CheckingBuffs[j]) then
--				for k = i, #QuickWarnings_CheckingBuffs_Researching do
--					QuickWarnings_CheckingBuffs_Researching[k] = QuickWarnings_CheckingBuffs_Researching[k + 1]
--				end
--				return
--			end
--		end
--		for j = 1, #QuickWarnings_CheckingBuffs_Ignore do
--			if (QuickWarnings_CheckingBuffs_Researching[i][1] == QuickWarnings_CheckingBuffs_Ignore[j]) then
--				for k = i, #QuickWarnings_CheckingBuffs_Researching do
--					QuickWarnings_CheckingBuffs_Researching[k] = QuickWarnings_CheckingBuffs_Researching[k + 1]
--				end
--				return
--			end
--		end
--	end
end

function QuickWarnings_OnEvent(self, event, ...)
	if (event == "COMBAT_LOG_EVENT_UNFILTERED") then
		local type, who, to = select(2,...), select(4,...), select(8,...)
		--ChatFrame1:AddMessage(to);
		--ChatFrame1:AddMessage(UnitGUID("player"));
		if (who == UnitGUID("player") and to == UnitGUID("player")) then
			--ChatFrame1:AddMessage(type);
			if (type == "SPELL_AURA_APPLIED") then -- or type == "SPELL_AURA_REFRESH") then
				local SpellID = select(12,...)
				--ChatFrame1:AddMessage(SpellID)
				local name, rank, icon = GetSpellInfo(SpellID);
				--ChatFrame1:AddMessage("Spell: |Hspell:" .. SpellID .."|h|r|cff71d5ff[" .. name .. " " .. rank .. "]|r|h");
				--ChatFrame1:AddMessage(icon)
				
				AddSpellToWatch(name, icon)
			elseif (type == "SPELL_AURA_REMOVED") then
				local SpellID = select(12,...)
				local name, rank, icon = GetSpellInfo(SpellID);
				--ChatFrame1:AddMessage("Spell: |Hspell:" .. SpellID .."|h|r|cff71d5ff[" .. name .. " " .. rank .. "]|r|h");
				--ChatFrame1:AddMessage(icon)
				
				RemoveSpellFromWatch(name)
			end
		end
	end
end